image: ubuntu:20.04
variables:
  GIT_SUBMODULE_STRATEGY: recursive
  DEBIAN_FRONTEND: noninteractive
stages:
  - build:renderer
  - build:site
  - deploy:site

build-renderer:
  stage: build:renderer
  before_script:
    - apt update && apt install -y build-essential
  script:
    - make build-renderer
  artifacts:
    paths:
      - "./renderer-src/renderer"
      - "./renderer-src/*.o"

build-site:
  stage: build:site
  needs: ["build-renderer"]
  before_script:
    - apt update && apt install -y build-essential git
  script:
    - make build-site
  artifacts:
    paths:
      - "./renderer-src/renderer"
      - "./build/"

pages:
  stage: deploy:site
  needs: ["build-site"]
  before_script:
    - apt update && apt install -y build-essential git
  script:
    - make deploy-site
  artifacts:
    paths:
      - "./build/"
      - "./public/"
  only:
  - master
